%% Statistical and numerical methods 2022
%% Exercise 2

%% Clean up
clear all; close all; clc


%% Assignment 1

% 1.1 Define constants
cInfinity = 0;
c0 = 1;
D = 10;

% Define integration function
g = @(s)exp(-s.^2);

% Preallocate result arrays
zeta = linspace(1e-6,3);
c = zeros(size(zeta));
cTrap = zeros(size(zeta));


% Calculate the solutions
for i = 1:length(zeta)
    c(i) = c0 + (cInfinity - c0)*2/sqrt(pi)*integral(g,0,zeta(i));
end

% Plot the concentration 
figure
plot(zeta,c, 'LineWidth', 2)


% Calculate the result
% 1.2 Trapzc gives first result
% 1.3 Trapzc_adapt gives improved result with adaptive procedure

% for i = 1:length(zeta)
% 	cTrap(i) = c0 + (cInfinity - c0)*2/sqrt(pi)*Trapzc(0, zeta(i), g, 3);
% end
for i = 1:length(zeta)
	cTrap(i) = c0 + (cInfinity - c0)*2/sqrt(pi)*Trapzc_adapt(0, zeta(i), g);
end

% Compare with integral
meanError = mean(abs(cTrap - c));
meanRelError = 100 * mean(abs(cTrap-c)./c);
fprintf('Mean error of Trapzc vs. integral: %g \n', meanError)
fprintf('Mean relative error of Trapzc vs. integral: %g %% \n', meanRelError)

% Plot it
hold on
plot(zeta,cTrap,'ro')
xlabel('\zeta', 'FontSize', 14)
ylabel('Concentration', 'FontSize', 14)
title('Concentration profile')
legend('integral','trapz','location','best')